import { Injectable } from '@nestjs/common';
import { BaseUpdateStatusManager } from 'src/core/modules/domain/usecase/managers/base-update-status.manager';
import { FaqEntity } from '../../entities/faq.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { FaqModel } from '../../../data/models/faq.model';
import { FaqChangeStatusEvent } from '../../entities/event/faq-change-status.event';

@Injectable()
export class InactiveFaqManager extends BaseUpdateStatusManager<FaqEntity> {
  getResult(): string {
    return `Success inactive data ${this.result.title}`;
  }

  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return FaqModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: FaqChangeStatusEvent,
        data: this.data,
      },
    ];
  }
}
